Subject: bug#32714: 26.1; Proposed language input methods --- Hawaiian

From: Bob Newell <[email-masked]>
Date: Tue, 11 Sep 2018 20:37:42 -1000

This is not a bug report per se but an offering of an enhancement. It
was suggested that I submit it through this method. If this is not
correct I apologize in advance and ask guidance on the proper
procedures.

I'm appending code for Hawaiian-language pre- and postfix input methods,
which would go in /lisp/leim/quail either as a standalone file or split
between the latin pre- and latin-post files.

Some years ago I signed FSF paperwork.

-- 
Bob Newell
Honolulu, Hawai`i
* Via Gnus/BBDB/Org/Emacs/Linux *

;;; Implement Hawaiian pre/post-fix input method. It's a small subset
;;; of Latin-4 with the addition of an ʻokina mapping. Hopefully the
;;; ʻokina shows correctly on most displays.

;;; You should be in one of the "Latin" language environments, such as
;;; (set-language-environment "Latin-4")

;;; This reference is an authoritative guide to Hawaiian orthography:
;;; http://www2.hawaii.edu/~strauch/tips/HawaiianOrthography.html

;;; Initial coding 2018-09-08 Bob Newell, Honolulu, Hawaiʻi
;;; Comments to [email-masked]

(require 'quail)

(quail-define-package
 "hawaiian-postfix" "Hawaiian Postfix" "H<" t
 "Hawaiian characters input method with postfix modifiers

             | postfix | examples
 ------------+---------+----------
  ʻokina     |    `    | ` -> ʻ
  kahakō     |    -    | a- -> ā

Doubling the postfix separates the letter and postfix. a-- -> a-
" nil t nil nil nil nil nil nil nil nil t)

(quail-define-rules
 ("A-" ?Ā)
 ("E-" ?Ē)
 ("I~" ?Ĩ)
 ("O-" ?Ō)
 ("U-" ?Ū)
 ("a-" ?ā)
 ("e-" ?ē)
 ("i-" ?ī)
 ("o-" ?ō)
 ("u-" ?ū)
 ("`" ?ʻ)

 ("A--" ["A-"])
 ("E--" ["E-"])
 ("I--" ["I-"])
 ("O--" ["O-"])
 ("U--" ["U-"])
 ("a--" ["a-"])
 ("e--" ["e-"])
 ("i--" ["i-"])
 ("o--" ["o-"])
 ("u--" ["u-"])
 ("``"  ["`"])
 )

(quail-define-package
 "hawaiian-prefix" "Hawaiian Prefix" "H>" t
 "Hawaiian characters input method with postfix modifiers

             | postfix | examples
 ------------+---------+----------
  ʻokina     |    `    | ` -> ʻ
  kahakō     |    -    | -a -> ā

Doubling the prefix separates the letter and prefix. --a -> -a
" nil t nil nil nil nil nil nil nil nil t)

(quail-define-rules
 ("-A" ?Ā)
 ("-E" ?Ē)
 ("~I" ?Ĩ)
 ("-O" ?Ō)
 ("-U" ?Ū)
 ("-a" ?ā)
 ("-e" ?ē)
 ("-i" ?ī)
 ("-o" ?ō)
 ("-u" ?ū)
 ("`" ?ʻ)

 ("--A" ["-A"])
 ("--E" ["-E"])
 ("--I" ["-I"])
 ("--O" ["-O"])
 ("--U" ["-U"])
 ("--a" ["-a"])
 ("--e" ["-e"])
 ("--i" ["-i"])
 ("--o" ["-o"])
 ("--u" ["-u"])
 ("``"  ["`"])
 )